#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Sep  9 08:36:33 2018
Machine learning practical 1 part 2
@author: thierrychateau
"""
import os
import numpy as np
from matplotlib import pyplot as plt
from matplotlib.colors import ListedColormap
from scipy.stats import multivariate_normal
from mpl_toolkits.mplot3d import Axes3D

import cv2
import pdb  #pdb.set_trace()

# plot a covariance 2D law in 3D
def plotGaus(mu,C, x_min=-1, x_max=1, y_min=-1, y_max=1, res=300\
             , title = 'Gaussian pdf'):
    #Create grid and multivariate normal
    x = np.linspace(x_min,x_max,res)
    y = np.linspace(y_min,y_max,res)
    X, Y = np.meshgrid(x,y)
    pos = np.empty(X.shape + (2,))
    pos[:, :, 0] = X; pos[:, :, 1] = Y
    rv = multivariate_normal(mu, C)   
    #Make a 3D plot
    fig = plt.figure()
    ax = fig.gca(projection='3d')
    ax.plot_surface(X, Y, rv.pdf(pos),cmap='viridis',linewidth=0)
    ax.set_xlabel('X axis')
    ax.set_ylabel('Y axis')
    ax.set_zlabel('Z axis')
    ax.set_title(title)

def getfeatures (path, cl):
    X = []
    scl = 'c'+str(cl)
    for i in os.listdir(path):
        print("processing file ",i)
        if os.path.isfile(os.path.join(path,i)) and scl in i:
            X.append(getfeature(path,i))
    return np.asarray(X)
def getfeature(path,filename):
    im = cv2.imread(path+filename)
    imrgb = cv2.cvtColor(im, cv2.COLOR_BGR2RGB)
    R = imrgb[:,:,0]
    G = imrgb[:,:,1]
    B = imrgb[:,:,2]
    # normalize
    In= R+G+B
    mIn = np.max((In.flatten()))
    Rn = R/mIn
    Gn = G/mIn
    Bn = B/mIn
    # Compute mean of each component
    X = [np.mean(Rn.flatten()),np.mean(Gn.flatten()),np.mean(Bn.flatten())]
    return X

def main():
    training_images_path ='images/dataset1/app/'
    testing_images_path ='images/dataset1/test/'
    X1 = getfeatures(training_images_path, 1)
    # Keep 2 first components
    X1 = X1[:,0:2]
    X2 = getfeatures(training_images_path, 2)
    # Keep 2 first components
    X2 = X2[:,0:2]
    Xtest1 = getfeatures(testing_images_path, 1)
    Xtest1 = Xtest1[:,0:2]
    Xtest2 = getfeatures(testing_images_path, 2)
    Xtest2 = Xtest2[:,0:2]
    #
    # Compute covariance matrices
    # TO BE FILL BY STUDENT
    # X1 and X2 are the features
    # C1 and C2 are covariance matrices (use np.cov() to compute)
    # mu1 and mu2 are mean vectors (use np.mean(.,axis = .) to compute)
    # TIPS: you may use np.transpose(.) if you need to.
    C1 = ...
    C2 = ...
    # Compute mean vectors
    mu1 = ...
    mu2 = ...
    #
    #pdb.set_trace()
    # display
    plt.plot(X1[:,0],X1[:,1],'+',label='Class 1')
    plt.plot(X2[:,0],X2[:,1],'o',label = 'Class2')
    plt.legend()
    plt.title('Training dataset: in feature space')
    plotGaus(mu1,C1, x_min=0, y_min=0, title='Gaussian pdf for Class 1')
    plotGaus(mu2,C2, x_min=0, y_min=0, title='Gaussian pdf for Class 2')
    plt.show()
if __name__ == "__main__":
    # execute only if run as a script
    main()
    

